<?php

namespace FiloBlu\CheckoutExtend\Block\Plugin\Checkout;

class LayoutProcessor {

    public $_helper;

    public function __construct(\FiloBlu\CheckoutExtend\Helper\Data $helper) {
        $this->_helper = $helper;
    }

    public function aroundProcess($subject, \Closure $proceed, $jsLayout) {

        # Shipping Additional Data
        $_shippingAdditionalData = $this->_helper->getShippingAddressAdditionalData();

        if ($_shippingAdditionalData && count($_shippingAdditionalData)) {

            foreach ($_shippingAdditionalData as $_additionalData) {
                if ($_additionalData['data_region'] == "tooltip") {
                    $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']
                            ['children']['shippingAddress']['children']['shipping-address-fieldset']
                            ['children'][$_additionalData['input_code']]['config'][$_additionalData['data_region']]["description"] = $_additionalData['label'];
                } else {
                    $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']
                            ['children']['shippingAddress']['children']['shipping-address-fieldset']
                            ['children'][$_additionalData['input_code']]['config'][$_additionalData['data_region']] = $_additionalData['label'];
                }
            }
        }

        # Move Coupon Into Totals
        if ($this->_helper->getConfigValue("filoblu_checkoutextend_section/totals/move_coupon_into_totals")) {
            $jsLayout['components']['checkout']['children']['steps']['children']['billing-step']
                    ['children']['payment']['children']['afterMethods']
                    ['children']['discount']['config']["componentDisabled"] = true;
            $jsLayout['components']['checkout']['children']['sidebar']['children']['summary']
                    ['children']['itemsBefore']['children']['discount'] = [
                            'component' => 'FiloBlu_CheckoutExtend/js/view/payment/discount',
                            'sortOrder' => 0,
                            'children' => [
                                'errors' => [
                                    'component' => 'Magento_SalesRule/js/view/payment/discount-messages',
                                    'sortOrder' => 0,
                                    'displayArea' => 'messages',
                                    ],
                            ],
                        ];
        }

        $customJsLayout = $proceed($jsLayout);

        return $customJsLayout;
    }

}
